---
title: MediaSession
slug: Web/API/MediaSession
tags:
  - API
  - Audio
  - Interface
  - Media
  - Media Session API
  - MediaSession
  - Reference
  - Video
---
<p>{{SeeCompatTable}}{{APIRef("Media Session API")}}</p>

<p><span class="seoSummary">The <strong><code>MediaSession</code></strong> interface of the <a href="/en-US/docs/Web/API/Media_Session_API">Media Session API</a> allows a web page to provide custom behaviors for standard media playback interactions, and to report metadata that can be sent by the user agent to the device or operating system for presentation in standardized user interface elements.</span></p>

<p>For example, a smartphone might have a standard panel in its lock screen that provides controls for media playback and information display. A browser on the device can use <code>MediaSession</code> to make browser playback controllable from that standard/global user interface.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("MediaSession.metadata", "metadata")}}</dt>
 <dd>Returns an instance of {{domxref("MediaMetadata")}}, which contains rich media metadata for display in a platform UI.</dd>
 <dt>{{domxref("MediaSession.playbackState", "playbackState")}}</dt>
 <dd>Indicates whether the current media session is playing. Valid values are <code>none</code>, <code>paused</code>, or <code>playing</code>.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("MediaSession.setActionHandler", "setActionHandler()")}}</dt>
 <dd>Sets an action handler for a <a href="/en-US/docs/Web/API/MediaSessionAction">media session action</a>, such as play or pause.</dd>
 <dt>{{domxref("MediaSession.setPositionState", "setPositionState()")}}</dt>
 <dd>Sets the current playback position and speed of the media currently being presented.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example creates a new media session and assigns action handlers to it:</p>

<pre class="brush: js notranslate">if ('mediaSession' in navigator) {
  navigator.mediaSession.metadata = new MediaMetadata({
    title: 'Unforgettable',
    artist: 'Nat King Cole',
    album: 'The Ultimate Collection (Remastered)',
    artwork: [
      { src: 'https://dummyimage.com/96x96',   sizes: '96x96',   type: 'image/png' },
      { src: 'https://dummyimage.com/128x128', sizes: '128x128', type: 'image/png' },
      { src: 'https://dummyimage.com/192x192', sizes: '192x192', type: 'image/png' },
      { src: 'https://dummyimage.com/256x256', sizes: '256x256', type: 'image/png' },
      { src: 'https://dummyimage.com/384x384', sizes: '384x384', type: 'image/png' },
      { src: 'https://dummyimage.com/512x512', sizes: '512x512', type: 'image/png' },
    ]
  });

  navigator.mediaSession.setActionHandler('play', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('pause', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('stop', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('seekbackward', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('seekforward', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('seekto', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('previoustrack', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('nexttrack', function() { /* Code excerpted. */ });
  navigator.mediaSession.setActionHandler('skipad', function() { /* Code excerpted. */ });
}</pre>

<p>The following example sets up two functions for playing and pausing, then uses them as callbacks with the relevant action handlers.</p>

<pre class="brush: js notranslate">const actionHandlers = [
  // play
  [
    'play',
    async function() {
      // play our audio
      await audioEl.play();
      // set playback state
      navigator.mediaSession.playbackState = "playing";
      // update our status element
      updateStatus(allMeta[index], 'Action: play  |  Track is playing...')
    }
  ],
  [
    'pause',
    () =&gt; {
      // pause out audio
      audioEl.pause();
      // set playback state
      navigator.mediaSession.playbackState = "paused";
      // update our status element
      updateStatus(allMeta[index], 'Action: pause  |  Track has been paused...');
    }
  ],
]

for (const [action, handler] of actionHandlers) {
  try {
    navigator.mediaSession.setActionHandler(action, handler);
  } catch (error) {
    console.log(`The media session action "${action}" is not supported yet.`);
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Media Session','#the-mediasession-interface','MediaSession')}}</td>
   <td>{{Spec2('Media Session')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.MediaSession")}}</p>
